%{

  #include <stdio.h>

  /* Include declaration of the tokens passed between scanner and parser.
     File parser.h is automatically generated by bison using the grammar. */
  #include "parser.h"

  /* The counter, in which line a word was found, is defined in the scanner. */
  extern unsigned int lineCounter;

  /* Forward declaration of error handling function. */
  void yyerror( char * );

%}

%token tID tWHILE tBEGIN tEND tDO tIF tTHEN
%token tELSE tSEMI tASSIGN
%start prog


%%


prog : stmlist;

stm : tID tASSIGN tID
    | tWHILE tID tDO stm
    | tBEGIN stmlist tEND
    | tIF tID tTHEN stm
    | tIF tID tTHEN stm tELSE stm;

stmlist : stm
        | stmlist tSEMI stm;


%%


/* Emit some error message. */
void yyerror( char *s )
{
  fprintf( stderr, "%s near line %ld.\n", s, lineCounter );
}


/* A complete C program needs a main function. */
int main()
{
  return yyparse();	/* Invoke parser which, in turn, invokes the scanner. */
}
