%{

  /* Include declaration of the tokens passed between scanner and parser.
     File parser.h is automatically generated by bison using the grammar. */
  #include "parser.h"

  /* Counter, in which line a word was found. */
  unsigned int lineCounter = 1;

  /* Forward declaration of helper function. */
  void incrementLineCounter();

%}

digit [0-9]
letter [a-zA-Z]
identifier {letter}({letter}|{digit})*


%%


 /* Matches keyword 'while'. */
while		return tWHILE;

 /* Matches keyword 'begin'. */
begin		return tBEGIN;

 /* Matches keyword 'end'. */
end		return tEND;

 /* Matches keyword 'do'. */
do		return tDO;

 /* Matches keyword 'if'. */
if		return tIF;

 /* Matches keyword 'then'. */
then		return tTHEN;

 /* Matches keyword 'else'. */
else		return tELSE;

 /* Matches ';'. */
";"		return tSEMI;

 /* Matches '=' operator. */
"="		return tASSIGN;


 /* Matches identifiers. */
{identifier}	return tID;

[ \t]		/* Consumes white spaces and tabs. */

 /* Consumes new-line characters. Increments line counter. */
\n		incrementLineCounter();


%%


/* Increment global variable lineCounter by 1. */
void incrementLineCounter()
{
  lineCounter++;
}
